package com.tzld.piaoquan.longarticle.utils.other;

import com.alibaba.fastjson.JSONObject;
import org.apache.commons.lang3.StringUtils;

import java.util.Objects;

public class GetContentUtil {
    public static void main(String[] args) {
        String articleTitle = "中国宣布重大消息，韩国被吓，美国不服气，俄罗斯和朝鲜都笑了！";
        String articleContent = "在当前国际政治舞台上，中朝关系、朝鲜半岛安全局势以及广泛的国际政治关系如同一副错综复杂的画卷，引人注目。\n" +
                "近期，中国外交部副部长孙卫东带领的代表团访问平壤的消息，为这幅画卷添上了新的一笔，引发了外界对中朝关系未来走向的广泛关注。\n" +
                "自1949年10月6日中华人民共和国与朝鲜民主主义人民共和国正式建交以来，两国之间的友好合作关系历经风雨，但总体上保持稳定发展。\n" +
                "两国在多个领域展开了深入合作，包括文化、教育、科技、体育和民生等领域，这些合作不仅加深了两国人民之间的相互理解和友谊，也为地区乃至全球的和平与发展作出了贡献。\n" +
                "在经济领域，作为朝鲜的重要贸易伙伴和物质援助国，中国对于朝鲜的经济发展起着至关重要的支持作用。中国提供的各种援助，帮助朝鲜在经济上保持稳定，助推其发展。\n" +
                "而在政治领域，中国一直致力于推动实现半岛无核化，维护朝鲜半岛及地区的和平稳定。在这一过程中，中朝两国保持了密切的沟通与协调。\n" +
                "\n" +
                "然而，朝鲜半岛的局势一直是国际政治关系中的一个热点问题。近年来，美国、日本和韩国加强了对朝鲜的军事压力，通过扩大联合军演、部署战略武器等方式，不断提升在半岛的军事存在感，这无疑增加了地区的紧张气氛。对此，俄罗斯表达了对朝鲜的支持，批评美日韩的军事行动，认为这些行动加剧了地区的不稳定因素。\n" +
                "在这个背景下，中国外交部副部长孙卫东此次访问朝鲜，显得尤为重要。此访旨在深化中朝传统友好，特别是在两国建交75周年之际，进一步加强经济合作，并就朝鲜半岛局势等共同关心的国际和地区问题交换意见。\n" +
                "这次访问不仅是两国关系发展的一个里程碑，也是在当前复杂国际形势下，中国致力于维护地区和平稳定、推动构建人类命运共同体理念的一个重要体现。\n" +
                "中朝双方的此次接触，无疑将为推动解决朝鲜半岛问题、维护地区和平稳定发挥积极作用。作为朝鲜半岛问题的直接相关方和重要的地区国家，中国一直倡导通过对话和协商解决问题，反对外部势力的军事干预和压力策略，这一立场在当前形势下显得尤为重要。\n" +
                "\n" +
                "未来，随着国际形势的不断变化，中朝之间的合作将更加多元化和深入。两国之间不仅在经济上互为支持，在维护地区和平稳定、推动构建更加公正合理的国际政治经济新秩序方面，也将发挥更加积极的作用。\n" +
                "作为国际社会的一份子，希望所有国家都能本着相互尊重、平等互利的原则，共同努力，为实现地区乃至全球的和平、稳定与发展作出应有的贡献。\n" +
                "在国际政治的大棋局中，中朝关系、朝鲜半岛的安全局势和国际政治关系的发展方向，始终是全球关注的焦点。本次中国外交部副部长孙卫东访问朝鲜，不仅是对两国传统友谊的再次肯定，更是在复杂的国际环境中，为维护地区和平稳定、推动构建人类命运共同体贡献中国的智慧和力量。\n" +
                "让我们共同关注并支持这一重要的外交行动，期待它为地区乃至全球的和平与发展带来积极影响。转发此消息，让更多人了解国际局势的最新动向，共同为世界和平与稳定发声。";
        String titleTxt = articleTitle + "\n" + promptGenerate("title");
//        String kimiTitle = KimiAPI.chat(titleTxt);
        String kimiTitle = "";
        if (StringUtils.isEmpty(kimiTitle)) {
            kimiTitle = GptAPI.chat(titleTxt);
        }
        if (StringUtils.isEmpty(kimiTitle)) {
            //TODO 处理异常
            System.out.println("error");
        }
        kimiTitle = kimiTitle.replaceAll("'", "").replaceAll("\"", "").replace("\\", "");
        System.out.println(kimiTitle);
        String contentTxt = promptGenerate("text") + "\n" + articleContent;
//        String kimiContent = KimiAPI.chat(contentTxt);
        String kimiContent = "";
        if (StringUtils.isEmpty(kimiContent)) {
            kimiContent = GptAPI.chat(contentTxt);
        }
        if (StringUtils.isEmpty(kimiContent)) {
            //TODO 处理异常
            System.out.println("error");
        }
        JSONObject jsonObject = JSONObject.parseObject(kimiContent);


    }


    public static String promptGenerate(String promptType) {
        if (Objects.equals(promptType, "title")) {
            return " 请将以上标题改写成适合小程序点击和传播的小程序标题，小程序标题的写作规范如下，请学习后进行小程序标题的编写。直接输出最终的小程序标题\n" +
                    "                小程序标题写作规范：\n" +
                    "                1.要点前置：将最重要的信息放在标题的最前面，以快速吸引读者的注意力。例如，“5月一辈子同学，三辈子亲，送给我的老同学，听哭无数人！”中的“5月”和“一辈子同学，三辈子亲”都是重要的信息点。\n" +
                    "                2.激发情绪：使用能够触动人心的语言，激发读者的情感共鸣。如“只剩两人同学聚会，看后感动落泪。”使用“感动落泪”激发读者的同情和怀旧情绪。\n" +
                    "                3.使用数字和特殊符号：数字可以提供具体性，而特殊符号如“\uD83D\uDD34”、“\uD83D\uDE04”、“\uD83D\uDD25”等可以吸引视觉注意力，增加点击率。\n" +
                    "                4.悬念和好奇心：创建悬念或提出问题，激发读者的好奇心。例如，“太神奇了!长江水位下降，重庆出现惊奇一幕!”中的“惊奇一幕”就是一个悬念。\n" +
                    "                5.名人效应：如果内容与知名人士相关，提及他们的名字可以增加标题的吸引力。\n" +
                    "                6.社会价值观：触及读者的文化和社会价值观，如家庭、友情、国家荣誉等。\n" +
                    "                7.标点符号的运用：使用感叹号、问号等标点来增强语气和情感表达。\n" +
                    "                8.直接的语言：使用直白、口语化的语言，易于理解，如“狗屁股，笑死我了!”。\n" +
                    "                9.热点人物或事件：提及当前的热点人物或事件，利用热点效应吸引读者。\n" +
                    "                10.字数适中：保持标题在10-20个字之间，既不过长也不过短，确保信息的完整性和吸引力。\n" +
                    "                11.适当的紧迫感：使用“最新”、“首次”、“紧急”等词汇，创造一种紧迫感，促使读者立即行动。\n" +
                    "                12.情感或价值诉求：使用如“感动”、“泪目”、“经典”等词汇，直接与读者的情感或价值观产生共鸣。\n" +
                    "                避免误导：确保标题准确反映内容，避免夸大或误导读者。";

        } else if (Objects.equals(promptType, "text")) {
            return "请从我给你的文章中挖掘出以下信息并且返回如下结果。\n" +
                    "                你返回的结果是一个 json, 格式如下:\n" +
                    "                {\n" +
                    "                    \"content_keys\": [] # 同时提供三个与文章内容高度相关的关键词，这些关键词将用于网络上搜索相关视频内容,\n" +
                    "                    \"content_title\": 一个总结性的标题，该标题应简洁并能够反映文章的主要内容\n" +
                    "                }\n" +
                    "                你需要处理的文本是：";
        } else {
            return "用中文帮我回答以下问题";
        }
    }
}
