package com.tzld.piaoquan.longarticle.utils.other;


import cn.hutool.json.JSONObject;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class SortUtil {

    private static double jcdTitleSimilarity(String oriTitle, String searchTitle) {
        Set<Character> set1 = new HashSet<>();
        for (char c : oriTitle.toCharArray()) {
            set1.add(c);
        }

        Set<Character> set2 = new HashSet<>();
        for (char c : searchTitle.toCharArray()) {
            set2.add(c);
        }

        Set<Character> intersection = new HashSet<>(set1);
        intersection.retainAll(set2);

        Set<Character> union = new HashSet<>(set1);
        union.addAll(set2);

        return (double) intersection.size() / union.size();
    }

    public static List<JSONObject> titleSimilarityRank(String contentTitle, List<JSONObject> recallList) {
        List<JSONObject> includeTitleList = new ArrayList<>();
        for (JSONObject videoInfo : recallList) {
            String platform = (String) videoInfo.get("platform");
            String title = "";

            if (platform.equals("dy_search") || platform.equals("baidu_search")) {
                title = (String) videoInfo.get("title");
            } else if (platform.equals("xg_search")) {
                title = (String) videoInfo.get("video_title");
            } else {
                continue;
            }

            videoInfo.put("title", title);
            videoInfo.put("score", jcdTitleSimilarity(contentTitle, title));
            includeTitleList.add(videoInfo);
        }

        includeTitleList.sort((a, b) -> Double.compare((double) b.get("score"), (double) a.get("score")));
        return includeTitleList;
    }
}
