package com.tzld.piaoquan.longarticle.utils.other;

import org.apache.commons.codec.digest.DigestUtils;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicHeader;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Objects;
import java.util.UUID;

public class VideoDownloader {

    private static final String PROXY_HOST = "l901.kdltps.com";
    private static final int PROXY_PORT = 15818;
    private static final String USERNAME = "t11983523373311";
    private static final String PASSWORD = "mtuhdr2z";
    private static final int MAX_RETRIES = 3;

    public static String downloadCover(String outVideoId, String platform, String coverUrl) {
        String path = generateCoverPath(platform, outVideoId);
        if (download(path, coverUrl, platform)) {
            return path;
        }
        return "";
    }

    public static String downloadVideo(String outVideoId, String platform, String videoUrl) {
        String path = generateVideoPath(platform, outVideoId);
        if (download(path, videoUrl, platform)) {
            return path;
        }
        return "";
    }

    public static boolean download(String path, String videoUrl, String platform) {
        try {

            int retries = 0;
            long fileSize = 0;

            while (retries < MAX_RETRIES) {
                File file = new File(path);
                if (file.exists()) {
                    file.delete();
                }
                HttpURLConnection connection = (HttpURLConnection) new URL(videoUrl).openConnection();
                connection.setRequestMethod("GET");
                connection.setRequestProperty("User-Agent", "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/131.0.0.0 Safari/537.36 Edg/131.0.0.0");
                connection.setRequestProperty("Accept", "*/*");
                connection.setRequestProperty("Range", "bytes=" + fileSize + "-");
                connection.setRequestProperty("accept-language", "en,zh;q=0.9,zh-CN;q=0.8");
                if (Objects.equals(platform, "dy_search")) {
                    connection.setRequestProperty("referer", "https://v11-coldf.douyinvod.com/");
                }


                // 设置代理
                System.setProperty("http.proxyHost", PROXY_HOST);
                System.setProperty("http.proxyPort", String.valueOf(PROXY_PORT));
                System.setProperty("http.proxyUser", USERNAME);
                System.setProperty("http.proxyPassword", PASSWORD);

                // 连接并获取响应
                connection.connect();

                int responseCode = connection.getResponseCode();
                if (responseCode == HttpURLConnection.HTTP_OK || responseCode == HttpURLConnection.HTTP_PARTIAL) {
                    // 下载文件
                    try (InputStream inputStream = connection.getInputStream();
                         OutputStream outputStream = new FileOutputStream(file, true)) { // 追加模式
                        byte[] buffer = new byte[1024 * 1024]; // 1MB buffer
                        int bytesRead;
                        while ((bytesRead = inputStream.read(buffer)) != -1) {
                            outputStream.write(buffer, 0, bytesRead);
                        }
                    }

                    // 检查文件是否为空
                    if (file.length() == 0) {
                        System.out.println("下载的文件为空，重试...");
                        retries++;
                        continue;
                    } else {
                        return true;
                    }
                } else {
                    System.out.println("下载失败，HTTP 状态码：" + responseCode);
                    retries++;
                }
            }

            System.out.println("下载失败，已达到最大重试次数：" + MAX_RETRIES);
            return false;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return false;
    }

    private static String generateVideoPath(String platform, String videoId) {
        String index = String.format("%s-%s-%s", platform, videoId, UUID.randomUUID());
        String md5Hash = DigestUtils.md5Hex(index);
        String fileName = String.format("%s.mp4", md5Hash);
        return String.join(File.separator, System.getProperty("user.dir"), fileName); // 返回文件路径和封面路径
    }

    private static String generateCoverPath(String platform, String videoId) {
        String index = String.format("%s-%s-%s", platform, videoId, UUID.randomUUID());
        String md5Hash = DigestUtils.md5Hex(index);
        String coverName = String.format("%s.png", md5Hash);
        return String.join(File.separator, System.getProperty("user.dir"), coverName); // 返回文件路径和封面路径
    }

}